<template>
  <p class="token-example" :style="isFontContext ? styleRule : null">
    <span v-if="isColorContext" :style="styleRule" class="box"></span>
    <span v-else-if="isFontContext">
      Lorem ipsum dolor sit amet consectetur adipisicing elit. Nostrum ratione illo eveniet reprehenderit minima quam
      recusandae iure doloribus dolorum quaerat, nemo, facilis, sapiente doloremque iusto alias ipsum quos dolor eum?
    </span>
    <span v-else-if="isSpacing" :style="styleRule" class="spacing">
      <span class="box"></span>
    </span>
    <span v-else-if="isBorderWidth" :style="styleRule" class="box"></span>
    <span v-else-if="isRounder" :style="styleRule" class="spacing"></span>
    <span v-else-if="isOpacity" class="spacing bg-contrast-base">
      <img :style="styleRule" src="https://picsum.photos/100" alt="Imagem aleatória de exemplo" />
    </span>
  </p>
</template>

<script>
const TokenExample = {
  name: "tokenExample",
  props: {
    currentContext: {
      type: String,
      default: null,
    },
    tokenCss: {
      type: String,
      default: null,
    },
  },
  computed: {
    isColorContext() {
      return this.currentContext === "color"
    },
    isFontContext() {
      return (
        this.currentContext === "fontWeight" ||
        this.currentContext === "fontSize" ||
        this.currentContext === "lineHeight" ||
        this.currentContext === "fontFamily"
      )
    },
    isSpacing() {
      return this.currentContext === "spacing"
    },
    isBorderWidth() {
      return this.currentContext === "borderWidth"
    },
    isRounder() {
      return this.currentContext === "rounder"
    },
    isOpacity() {
      return this.currentContext === "opacity"
    },
    styleRule() {
      switch (this.currentContext) {
        case "color":
          return `background: var(${this.tokenCss})`
        case "fontWeight":
          return `font-weight: var(${this.tokenCss})`
        case "fontSize":
          return `font-size: var(${this.tokenCss})`
        case "fontFamily":
          return `font-family: var(${this.tokenCss})`
        case "lineHeight":
          return `line-height: var(${this.tokenCss})`
        case "spacing":
          return `padding: var(${this.tokenCss})`
        case "borderWidth":
          return `border-width: var(${this.tokenCss})`
        case "rounder":
          return `border-radius: var(${this.tokenCss})`
        case "opacity":
          return `opacity: var(${this.tokenCss})`
        case "scrim":
          return `var(${this.tokenCss})`
        case "grid":
          return `var(${this.tokenCss})`
        case "elevation":
          return `var(${this.tokenCss})`
        case "motion":
          return `var(${this.tokenCss})`
        default:
          return null
      }
    },
  },
}

export default TokenExample
</script>

<style scoped></style>
